package de.fzj.unicore.bes.security;

import java.util.logging.Level;
import java.util.logging.Logger;
import static org.junit.Assert.*;

import java.io.FileNotFoundException;

import org.junit.Test;

/**
 *
 * Test class to handle FilebasedUsername mapping class.
 * @author m.memon
 *
 */
public class UserNameValidatorTest {

    @Test
    public void testValidation() {
        FileBasedUsernameValidator validator;
        try {
            validator = FileBasedUsernameValidator.getInstance("src/test/resources/secure/users.xml");
            assertTrue(validator.validate("user1", "user1"));
            assertTrue(validator.validate("user2", "user2"));
            assertFalse(validator.validate("user2", "user1"));
            System.out.println("Testing non existing user:");
            assertFalse(validator.validate("NonExistingUser", "password"));
        } catch (Exception ex) {
            Logger.getLogger(UserNameValidatorTest.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Test(expected = FileNotFoundException.class)
    public void testHandleNonexistentFile() throws Exception {
        FileBasedUsernameValidator.getInstance("non-existent-map-file.xml");
    }
}
