package de.fzj.unicore.uas.fts.rft;

import java.io.OutputStream;

import de.fzj.unicore.uas.client.ReliableFileTransferClient;
import de.fzj.unicore.xnjs.tsi.TSI;

public class ChunkImpl implements ReliableFileTransferClient.Chunk {

	private final TSI storage;
	
	private final String path;

	private final long offset;

	private final long length;
	
	private final int index;
	
	public ChunkImpl(int index, TSI storage, String path, long offset, long length) {
		this.index=index;
		this.storage = storage;
		this.path = path;
		this.offset = offset;
		this.length = length;
	}

	@Override
	public long getLength() {
		return length;
	}

	@Override
	public long getOffset() {
		return offset;
	}

	@Override
	public OutputStream newOutputStream() throws Exception{
		return storage.getOutputStream(path);
	}

	public int getIndex(){
		return index;
	}
	
	public String toString(){
		return "Chunk["+offset+"-"+(offset+length)+" "+path+"]";
	}
	
}
