package de.fzj.unicore.uas.impl.dsms;

import java.util.concurrent.Callable;

import org.unigrids.services.atomic.types.GridFileType;

import pl.edu.icm.dsms.catalogue.model.Lda;
import de.fzj.unicore.uas.client.StorageClient;
import de.fzj.unicore.wsrflite.Kernel;
import eu.unicore.security.Client;

public class ListDirectoryCallable implements Callable<GridFileType[]>
{
	private final Lda lda;
	private final Client client;
	private final Kernel kernel;
	
	public ListDirectoryCallable(Lda lda, Client client, Kernel kernel)
	{
		this.lda = lda;
		this.client = client;
		this.kernel = kernel;
	}

	@Override
	public GridFileType[] call() throws Exception
	{
		StorageClient sms = Utils.getStorageClient(lda, client, kernel);
		return sms.listDirectory(lda.getPhysicalName());
	}

}
