package de.fzj.unicore.uas.dsms.stress;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class DirectoryList {
	private List<Directory> dirs;
	private List<List<Directory>> dirsByLevel;

	private int currentDir, subdirDepth;
	private Random r;

	public DirectoryList(int dirsNo, int subdirDepth, String parent) {
		this.dirs = new ArrayList<Directory>();
		this.dirsByLevel = new ArrayList<List<Directory>>();
		this.currentDir = 0;
		this.subdirDepth = subdirDepth;
		this.r = new Random();

		dirsByLevel.add(new ArrayList<Directory>());
		dirsByLevel.get(0).add(new Directory(parent));

		generate(dirsNo);
	}

	void generate(int dirsNo) {
		for (int i = 0; i < dirsNo; i++) {
			int level = r.nextInt(subdirDepth) + 1;
			if (dirsByLevel.size() < level) {
				level = dirsByLevel.size();
			}
			List<Directory> parentList = dirsByLevel.get(level - 1);
			Directory parent = parentList.get(r.nextInt(parentList.size()));
			Directory dir = parent.createSubdir("dir_" + dirs.size());
			if (dirsByLevel.size() == level) {
				dirsByLevel.add(new ArrayList<Directory>());
			}
			dirsByLevel.get(level).add(dir);
			dirs.add(dir);
		}
	}

	synchronized public Directory getNext() {
		if (currentDir >= dirs.size()) {
			return null;
		} else {
			return dirs.get(currentDir++);
		}
	}

	synchronized public Directory getRandom() {
		int s = dirs.size();
		if (s == 0) {
			return null;
		} else {
			return dirs.get(r.nextInt(s));
		}
	}
}