package de.fzj.unicore.uas.jmx;

import junit.framework.TestCase;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import de.fzj.unicore.uas.UAS;
import de.fzj.unicore.uas.admin.UASAdmin;
import de.fzj.unicore.wsrflite.Kernel;

public class TestUASAdminBean extends TestCase{

	public void testUASAdminBean()throws Exception{
		UAS uas=new UAS("src/test/resources/minimal/wsrflite.xml");
		uas.startSynchronous();
		
		UASAdmin u=new UASAdmin(uas);
		
		assertEquals("DEMO-SITE", u.getSiteName());
		
		assertEquals("false",u.getAccessControlEnabled());
		
		assertEquals(uas.getKernel().getProperty(Kernel.WSRF_BASEURL),u.getBaseURL());
		
		assertEquals("false",u.getIsSharedRegistry());
				
		assertEquals("false",u.getRequireSignatureEnabled());
		
		assertEquals("false",u.getProxyCertificateSupportEnabled());
		
		assertEquals("<n/a>",u.getGatewayIdentity());
		
		assertNotNull(u.getAttributeSourcesStatus());
		
		assertEquals(1,u.getExternalRegistryURLs().length);
		assertEquals("<using internal registry>",u.getExternalRegistryURLs()[0]);
		
		String key="foo";
		String value="bar";
		u.setProperty(key, value);
		assertEquals("bar",uas.getKernel().getProperty("foo"));
		
		u.setLogLevel("some.test.logger", "DEBUG");
		assertEquals(Level.DEBUG, Logger.getLogger("some.test.logger").getLevel());
		
	}
	
}
