package de.fzj.unicore.uas.fts.udt;

import de.fzj.unicore.uas.CoreClientCapabilities.FTClientCapability;
import de.fzj.unicore.uas.client.FileTransferClient;
import de.fzj.unicore.uas.client.UDTClient;
import de.fzj.unicore.uas.fts.FileTransferCapability;
import de.fzj.unicore.uas.fts.FileTransferImpl;
import de.fzj.unicore.uas.xnjs.U6FileTransferBase;
import de.fzj.unicore.wsrflite.Capabilities;
import de.fzj.unicore.wsrflite.Capability;
import de.fzj.unicore.wsrflite.ClientCapabilities;
import de.fzj.unicore.wsrflite.ClientCapability;

/**
 * for advertising he UFTP capabilities to the UNICORE/X container
 * 
 * @author schuller
 */
public class UDTCapabilities implements ClientCapabilities, Capabilities{

	@Override
	public ClientCapability[] getClientCapabilities() {
		return new ClientCapability[]{
				UDTClientCapability
		};
	}
	
	@Override
	public Capability[] getCapabilities() {
		return new Capability[]{
				UDTCapability
		};
	}

	
	private static ClientCapability UDTClientCapability=new FTClientCapability(){

		@Override
		public Class<? extends FileTransferClient> getImplementation() {
			return UDTClient.class;
		}

		@Override
		public String getProtocol() {
			return "UDT";
		}

		@Override
		public Class<?> getInterface() {
			return FileTransferClient.class;
		}

	}; 
	

	private static Capability UDTCapability = new FileTransferCapability(){

		@Override
		public String getProtocol() {
			return "UDT";
		}

		@Override
		public Class<?> getImplementation() {
			return UDTFileTransferImpl.class;
		}

		@Override
		public Class<?> getInterface() {
			return FileTransferImpl.class;
		}
		
		@Override
		public Class<? extends U6FileTransferBase> getExporter() {
			return UDTExport.class;
		}

		@Override
		public Class<? extends U6FileTransferBase> getImporter() {
			return UDTImport.class;
		}
	};
	
}
