package de.fzj.unicore.uas.fts.udt;

import java.util.Collections;

import javax.xml.namespace.QName;

import org.unigrids.x2006.x04.services.fts.TransferredBytesDocument;

import de.fzj.unicore.wsrflite.exceptions.InvalidModificationException;
import de.fzj.unicore.wsrflite.xmlbeans.ModifiableResourceProperty;
import de.fzj.unicore.wsrflite.xmlbeans.impl.WSResourceImpl;

public class UDTTransferredBytesProperty extends ModifiableResourceProperty<TransferredBytesDocument, Long> {

	private static final long serialVersionUID = 1L;
	
	public UDTTransferredBytesProperty(QName type, WSResourceImpl parent,
			boolean checkSchema) {
		super(type, parent, checkSchema);
	}

	public UDTTransferredBytesProperty(QName type, WSResourceImpl parent) {
		super(type, parent);
	}

	@Override
	public boolean checkPermissions(int permissions) {
		return permissions==WSResourceImpl.UPDATE;
	}
	

	@Override
	public UDTTransferredBytesProperty update() throws Exception {
		TransferredBytesDocument tbd=TransferredBytesDocument.Factory.newInstance();
		tbd.setTransferredBytes(((UDTFileTransferImpl)parentWSResource).getTransferredBytes());
		try {
			update(Collections.singletonList(tbd));
		} catch (InvalidModificationException e) {
			logger.warn("Internal error",e);
		}	
		return this;
	}

}
